export default class Connections {
    connections = new Map();
    disconnect(object) {
        for (const id of this.connections.get(object) ?? []) {
            object.disconnect(id);
        }
    }
    disconnect_all() {
        for (const [obj, ids] of this.connections.entries()) {
            for (const id of ids) {
                obj.disconnect(id);
            }
        }
    }
    push(object, id) {
        let ids = this.connections.get(object);
        if (ids === undefined) {
            ids = [];
            this.connections.set(object, ids);
        }
        ids.push(id);
    }
    connect(object) {
        return (id, callback) => {
            const connection = object.connect(id, callback);
            this.push(object, connection);
            return connection;
        };
    }
    connect_after(object) {
        return (id, callback) => {
            const connection = object.connect_after(id, callback);
            this.push(object, connection);
            return connection;
        };
    }
}
